"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];
var _typeof = require("@babel/runtime/helpers/typeof")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = _interopRequireWildcard(require("react"));
var _bemCnLite = _interopRequireDefault(require("bem-cn-lite"));
var _uikit = require("@gravity-ui/uikit");
require("./TumblerControl.scss");
var _jsxRuntime = require("react/jsx-runtime");
var _excluded = ["value", "onChange"],
  _excluded2 = ["labelLeft", "labelRight", "size", "className"];
function _getRequireWildcardCache(nodeInterop) {
  if (typeof WeakMap !== "function") return null;
  var cacheBabelInterop = new WeakMap();
  var cacheNodeInterop = new WeakMap();
  return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) {
    return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
  })(nodeInterop);
}
function _interopRequireWildcard(obj, nodeInterop) {
  if (!nodeInterop && obj && obj.__esModule) {
    return obj;
  }
  if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
    return {
      "default": obj
    };
  }
  var cache = _getRequireWildcardCache(nodeInterop);
  if (cache && cache.has(obj)) {
    return cache.get(obj);
  }
  var newObj = {};
  var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var key in obj) {
    if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
      var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
      if (desc && (desc.get || desc.set)) {
        Object.defineProperty(newObj, key, desc);
      } else {
        newObj[key] = obj[key];
      }
    }
  }
  newObj["default"] = obj;
  if (cache) {
    cache.set(obj, newObj);
  }
  return newObj;
}
var block = (0, _bemCnLite["default"])('df-tumbler-control');
function TumblerControl(_ref) {
  var value = _ref.value,
    onChange = _ref.onChange,
    extras = (0, _objectWithoutProperties2["default"])(_ref, _excluded);
  var onTumblerChange = (0, _react.useCallback)(function () {
    return onChange(!value);
  }, [onChange, value]);
  var labelLeft = extras.labelLeft,
    labelRight = extras.labelRight,
    _extras$size = extras.size,
    size = _extras$size === void 0 ? 'm' : _extras$size,
    className = extras.className,
    rest = (0, _objectWithoutProperties2["default"])(extras, _excluded2);
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("span", {
    className: block({
      size: size
    }),
    children: [labelLeft, /*#__PURE__*/(0, _jsxRuntime.jsx)(_uikit.Switch, (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, rest), {}, {
      size: size,
      className: block('switch', {
        'label-left': Boolean(labelLeft),
        'label-right': Boolean(labelRight)
      }, className),
      onChange: onTumblerChange,
      checked: value
    })), labelRight]
  });
}
TumblerControl.getDefaultValue = function () {
  return false;
};
TumblerControl.isEmpty = function (value) {
  return typeof value !== 'boolean' || !value;
};
var _default = TumblerControl;
exports["default"] = _default;
// #sourceMappingURL=TumblerControl.js.map
// #sourceMappingURL=TumblerControl.js.map